#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Duplicate Link Checker
# DIZ: Lets you check for duplicate links inside the Directory/Index
# GRAPHIC: ic_dupl.gif
# VERSION: 1.0 Beta
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;
use LWP::UserAgent;


&get_setup;
$q = CGI->new;

### FIELD extf3 = reciprocal link

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "checklinks") { &checklinks; }
if ($q->param('fct') eq "manlinks") { &manlinks; }
if ($q->param('fct') eq "link_operations") { &link_operations; }
if ($q->param('fct') eq "filt_and_delete") { &filt_and_delete; }

##################################################################################

sub filt_and_delete
{

if ($q->param('filter_submit') eq "Submit")
	{
	&set_filter_option;
	}
	elsif ($q->param('del_submit1') eq "Delete All Duplicate Links")
	{
	&delete_duplicates_only;
	}
	elsif ($q->param('del_submit2') eq "Delete All Links That Creates Duplicates")
	{
	&delete_duplicates_with_originals;
	}
	
}



sub delete_duplicates_with_originals
{

$dup_linkids = acs::get_file_contents("$data_dir/dupcheck.dat");
@all_duplc = split (/\n/, $dup_linkids);

		foreach $item (@all_duplc)
		{
		($lnkid, $url) = split (/:::/, $item);
		push (@urlsonly, $url);
		}

		@urlsonly = sort(@urlsonly);
	
		foreach $item (@urlsonly)
		{
		if ($last_url ne $item)
			{
			$sql_w = $sql_w . "(url = '$item') OR ";
			}
		$last_url = $item;
		}

$sql_w = substr($sql_w, 0, length($sql_w) - 3);

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "DELETE FROM links WHERE $sql_w";
$sth = $dbh->prepare($sql); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows(); 

$sth->finish;
$dbh->disconnect; 

$stat = unlink("$data_dir/dupcheck.dat");

$hbox = acs::get_heading_box("$web_url/ic_del.gif", "$rows Duplicates With Originals Deleted", qq[
Links that creates duplicates has been deleted with their orignals. (The original links has been removed as well)<BR>
<a href="$admin_url/p_dupl.cgi?fct=manlinks">Click Here to Continue</a>
]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}



sub delete_duplicates_only
{

$dup_linkids = acs::get_file_contents("$data_dir/dupcheck.dat");
@all_duplc = split (/\n/, $dup_linkids);

	foreach $item (@all_duplc)
		{
		($lnkid, $url) = split (/:::/, $item);
		
		if ($item ne "")
			{
			$sql_w = $sql_w . "(lnkid = '$item') OR ";
			}
		}

$sql_w = substr($sql_w, 0, length($sql_w) - 3);

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "DELETE FROM links WHERE $sql_w";
$sth = $dbh->prepare($sql); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows(); 

$sth->finish;
$dbh->disconnect; 

$stat = unlink("$data_dir/dupcheck.dat");

$hbox = acs::get_heading_box("$web_url/ic_del.gif", "$rows Duplicate Links Deleted", qq[
Links that creates duplicates has been deleted. The original links has not been removed only links that creates duplicates with them.<BR>
<a href="$admin_url/p_dupl.cgi?fct=manlinks">Click Here to Continue</a>
]); 

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];




}



sub set_filter_option
{

if ($q->param('listoptions') eq "only_duplicates")
	{
	open (DUPLSET, "> $data_dir/duplicates.cfg");
		print DUPLSET "only_duplicates";
	close (DUPLSET);
	}
	else
	{
	open (DUPLSET, "> $data_dir/duplicates.cfg");
		print DUPLSET "all_links";
	close (DUPLSET);	
	}


$hbox = acs::get_heading_box("$web_url/ic_del.gif", "Changing Setting.", qq[
Working...
]); 


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/p_dupl.cgi?fct=manlinks">
</head>
<body>
$hbox
</body>
</html>
];

}



sub link_operations
{
$dropdown1 =  $q->param('dropdown1');
$dropdown = $q->param('dropdown');
$itemnr = $q->param('itemnr');


### CHECK IF SOMETHING WAS SELECTED

for ($ms = 0; $ms < ($itemnr + 1); $ms++) 
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "")
		{
		$foundmatch = "true";
		
		$lnkid = $q->param($cname);
		$sql_w = $sql_w . " (lnkid = '$lnkid') OR ";
		
		push (@sel_links, $lnkid);
		}
	}
				

if ( $foundmatch ne "true")
	{
	acs::problem_popup("You have to at least select one listing."); 
	}



if (($q->param('B2') ne "") and ($q->param('dropdown1') eq "del_database")) 
	{
	$action_do = "del_database";
	}
	elsif (($q->param('B2') ne "") and ($q->param('dropdown1') eq "del_que")) 
	{
	$action_do = "del_que";
	}
	elsif (($q->param('B1') ne "") and ($q->param('dropdown') eq "del_database")) 
	{
	$action_do = "del_database";
	}
	elsif (($q->param('B1') ne "") and ($q->param('dropdown') eq "del_que")) 
	{
	$action_do = "del_que";
	}




if ($action_do eq "del_database")
	{
	$sql_w = substr($sql_w, 0, length($sql_w) - 3);

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$sql = "DELETE FROM links WHERE $sql_w";
	$sth = $dbh->prepare($sql); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	$rows = $sth->rows(); 

	$sth->finish;
	$dbh->disconnect; 

	$hbox = acs::get_heading_box("$web_url/ic_del.gif", "Link(s) Deleted From Database", qq[
	<a href="$admin_url/p_dupl.cgi?fct=manlinks">Click Here to Continue</a>
	]); 
	
	}
elsif ($action_do eq "del_que")
	{
	$dup_linkids = acs::get_file_contents("$data_dir/dupcheck.dat");
	@all_duplc = split (/\n/, $dup_linkids);
	
	foreach $item (@all_duplc)
		{
		($lnkid, $url) = split (/:::/, $item);
		
			$foundm = "false";
			foreach $sel_item (@sel_links)
				{
				if ($lnkid == $sel_item)
					{
					$foundm = "true";
					}
				}
		
			if ($foundm ne "true")
				{
				push (@towrite, $item);
				}
		
		}
	

	open (DUPLW, "> $data_dir/dupcheck.dat");
		foreach $item (@towrite)
			{
			print DUPLW $item . "\n";
			}
	close (DUPLW);
	

	$hbox = acs::get_heading_box("$web_url/ic_del.gif", "Link(s) Deleted From Que", qq[
	<a href="$admin_url/p_dupl.cgi?fct=manlinks">Click Here to Continue</a>
	]); 	
	}

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}





sub manlinks
{

$dup_setting = acs::get_file_contents("$data_dir/duplicates.cfg");
if ($dup_setting eq "all_links") { $all_links_sel = "selected"; } else { $only_duplicates_sel = "selected"; }


$dup_linkids = acs::get_file_contents("$data_dir/dupcheck.dat");
@all_duplc = split (/\n/, $dup_linkids);


if ($dup_setting eq "all_links")
	{
		foreach $item (@all_duplc)
		{
		($lnkid, $url) = split (/:::/, $item);
		push (@urlsonly, $url);
		}

		@urlsonly = sort(@urlsonly);
	
		foreach $item (@urlsonly)
		{
		if ($last_url ne $item)
			{
			$sql_w = $sql_w . "(url = '$item') OR ";
			}
		$last_url = $item;
		}
	
	$list_option_description = "Listing All Links That Creates Duplicates (Listing the Original + It's Duplicates)";
	
	}
	else
	{
	foreach $item (@all_duplc)
		{
		($lnkid, $url) = split (/:::/, $item);
		
		if ($item ne "")
			{
			$sql_w = $sql_w . "(lnkid = '$item') OR ";
			}
		}
	$list_option_description = "Listing Only Links That Creates Duplicates (Not listing original's - only listing it's duplicates)";
	}

$sql_w = substr($sql_w, 0, length($sql_w) - 3);


if ($sql_w ne "") ### IF A DUPLICATE LINK REPORT EXISTS
	{

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	
	### GET TOTAL NUMBER OF RECORDS
	if ($q->param('total') eq "")
		{
		$sql = "SELECT COUNT(*) FROM links WHERE $sql_w ORDER BY url ASC";
		$sth = $dbh->prepare($sql); 
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		$cnt = 0;
			while ( @row = $sth->fetchrow() )
				{
				$total = $row[0];
				}
		}
		else
		{
		$total = $q->param('total');
		}

	### PREPARE PAGES
	$st = $q->param('st');
	$nd = $q->param('nd');
	$nr_searchres = 50;
	$icnt = $total;
	$modp = ($icnt % $nr_searchres);
	$pages = ($icnt - $modp) / $nr_searchres;
	if ($modp != 0) {$pages++;}
	if ($st eq ""){$st = 0;}
	if ($nd eq ""){$nd = $nr_searchres;}
	$ippc = 1; 
	$cc = 0;


	### FETCH RECORDS

	$sql = "SELECT * FROM links WHERE $sql_w ORDER BY url ASC LIMIT $st, $nr_searchres";
	$sth = $dbh->prepare($sql); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	$cnt = 0;
	$rows = $sth->rows();


	
	##### CREATE RECORDS

	$rowcounter = 0;
	$item_nr = $st + 1;
	
	while ( @row = $sth->fetchrow() )
		{
	
		if ($row[16] eq "") { $row[16] = "<b>None</b>"; }
		$date = acs::decode_date($row[17]);
		 
		 $cname = "C" . $cnt;
		 
		 $check_all_boxes = $check_all_boxes . "'C" . $cnt . "',";
	
		$all_link_disp = $all_link_disp . qq[
		<table border="0" cellpadding="6" cellspacing="1" width="100%">
		  <tr>
	    <td width="1%" valign="top" class="normaltext"><input type="checkbox" name="$cname" value="$row[0]"></td>
	    <td width="99%" class="normaltext" style="border-left: 1px solid rgb(218,218,218)">
	    $item_nr. <a href="$row[5]" target="_blank"><b>$row[2]</b></a><br>
	    $row[3]<br>
	    <strong>$row[5]</strong><br>
	    <b>Date:</b> $date | <b>Rating:</b> $row[10] | <b>Votes:</b> $row[11] | <b>Hits:</b>
	    $row[12]<br>
	    <b>Category: </b>!!cid-$row[1]!!<BR>
	    User Account: $row[16]<BR>
	    <b>[
	    <a href="" onClick="popup('$admin_url/admin56.cgi?itemnrs=2&C0=$row[0]-$row[1]&dropdown=Edit&B1=Submit',700,600);return false;">Edit</a>
	    ] [
	    <a href="" onClick="popup('$admin_url/admin56.cgi?fct=delete_listings&links=$row[0]',700,600);return false;">Delete From Database</a> ] </b></td>
	  </tr>
	</table><BR>
		];
	
		$cat_sql = $cat_sql . " (cid = $row[1]) OR ";
		$cnt++;
		$rowcounter++;
		$item_nr++;
		}

	chop($check_all_boxes);
	$cat_sql = substr($cat_sql, 0, length($cat_sql) - 3);


		if ($rows > 0) ### IF DUPLICATE MATCHES FOUND
		{
	
		$sql = "SELECT * FROM dirs WHERE $cat_sql";
		$sth = $dbh->prepare($sql); 
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

		while ( @row = $sth->fetchrow() )
			{
			$rccat = ""; $cats3 = "";
			for ($ms3 = 2; $ms3 < 18; $ms3++) 
				{
				if ($row[$ms3] ne "")
					{
					$rccat = $rccat . $row[$ms3] . "/";
					$cats3 = $cats3 . acs::encode_dir($row[$ms3]) . "-";
					}
				}  
			$cat_rpl = qq[<a href="$admin_url/admin12.cgi?fct=gotocat&ct=$cats3&cid=$row[0]" target="_blank">$rccat</a>];
			$all_link_disp =~ s/!!cid-$row[0]!!/$cat_rpl/g;
			}
		}


	
	### GET PAGES
	
	for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres))
			{
			$pgstring = $pgstring . " [$pg] ";
			$targpage = $pg;
			}
		  	else
			{
			$st1 = ($pg * $nr_searchres) - $nr_searchres;
			$nd1 = ($pg * $nr_searchres);
			$pgstring = $pgstring . "<a href=\"$admin_url/p_dupl.cgi?st=$st1&nd=$nd1&fct=manlinks&total=$total\">$pg</a> ";
			}
		}


	if ($pages > 1)
		{
		$pgstring = "| Pages: " . $pgstring;
		}
		else
		{
		$pgstring = "";
		}

	$page_crit = $page_crit .  $pgstring;


	$sth->finish;
	$dbh->disconnect; 

} ### END IF ORIGINAL SQL QUERY THAT FETCHES DUPLICATE LINK DETAILS


	
### GET CATEGORIES

if ($all_link_disp ne "")
{

$form_start = qq[<form method="POST" action="$admin_url/p_dupl.cgi" name="select_all">
<input type="hidden" name="fct" value="link_operations">
<input type="hidden" name="itemnr" value="$rowcounter">

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DADADA">
  <tr>
    <td width="1014" height="30" background="$web_url/bar6.gif"
    bgcolor="#FFFFFF" class="normaltext"><strong>$list_option_description</strong></td>
  </tr>
  <tr>
    <td width="1014" bgcolor="#FFFFFF" class="normaltext"> <span class="normaltext"><a
    href="javascript:checkall('select_all',true)"><b>Check All</b></a> | <a
    href="javascript:checkall('select_all',false)"><b>UnCheck All</b></a> $pgstring</span></td>
  </tr>
  <tr>
    <td width="1014" bgcolor="#FFFFFF" class="normaltext"><span class="normaltext"></span><select
    name="dropdown1" size="1">
      <option value="del_database">Delete Checked Links From Database</option>
      <option value="del_que">Delete Checked Links From Que (Don't Delete Links from Database)</option>
    </select> <input type="submit" value="Submit" name="B2"><span class="normaltext"></span></td>
  </tr>
</table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>


</span>
<hr size="1" color="#E8E8E8">
];

$form_end = qq[
<hr size="1" color="#E8E8E8">
 <select name="dropdown" size="1">
    <option value="del_database">Delete Checked Links From Database</option>
    <option value="del_que">Delete Checked Links From Que (Don't Delete Links from Database)</option>
  </select>
<input type="submit" value="Submit" name="B1">
<span class="normaltext">
<a href="javascript:checkall('select_all',true)">Check All</a> | <a href="javascript:checkall('select_all',false)">UnCheck All</a>
$pgstring
</span>
</form>
];
	

$filter_delete_options = qq[<form method="POST" action="$admin_url/p_dupl.cgi">
  <input type="hidden" name="fct" value="filt_and_delete"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DADADA">
    <tr>
      <td width="1014" height="30" background="$web_url/bar6.gif" bgcolor="#FFFFFF"
      class="normaltext" colspan="2"><strong>Filter Options</strong></td>
    </tr>
    <tr>
      <td width="1014" bgcolor="#FFFFFF" class="normaltext" colspan="2"><select
      name="listoptions" size="1">
        <option value="only_duplicates" $only_duplicates_sel>List Only Links That Creates Duplicates (Original's will not be listed but only links that creates duplicates)</option>
        <option value="all_links" $all_links_sel>List All Links That Creates Duplicates (Originals + their duplicates will be listed)</option>
      </select><input type="submit" value="Submit" name="filter_submit"><ul>
        <li>If you choose to 'List only links that creates duplicates' then only links that creates
          duplicates will be listed. The original link will not be listed but only it's duplicates.</li>
        <li>If you choose to 'List All Links That Creates Duplicates' then all links that creates
          duplicates with each other will be listed including the original link.</li>
      </ul>
      </td>
    </tr>
    <tr>
      <td width="1014" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"
      colspan="2"><strong>Deletion Options</strong></td>
    </tr>
    <tr>
      <td width="151" bgcolor="#FFFFFF" class="normaltext"><strong><input type="submit"
      value="Delete All Duplicate Links" name="del_submit1"></strong></td>
      <td width="849" bgcolor="#FFFFFF" class="normaltext">Delete all duplicate links. (Only one
      copy of the links will remain so that duplicates is not possible)</td>
    </tr>
    <tr>
      <td width="151" bgcolor="#FFFFFF" class="normaltext"><strong><input type="submit"
      value="Delete All Links That Creates Duplicates" name="del_submit2"></strong></td>
      <td width="849" bgcolor="#FFFFFF" class="normaltext">Delete all links that creates
      duplicates. Delete duplicate links including the original link.</td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form> 

];

}
else
{

$filter_delete_options = qq[
<table border="0" cellspacing="1" width="1028" cellpadding="6" bgcolor="#DADADA">
  <tr>
    <td width="1014" bgcolor="#FFFFFF" class="normaltext" align="center">There are no
    duplicate links in the 'Duplicate Links Report' at the moment. <p><a
    href="$admin_url/p_dupl.cgi?fct=checklinks">Click Here</a> to check the database for
    duplicate links.</td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
];

}





$hbox = acs::get_heading_box("$web_url/ic_del.gif", "Manage Duplicate Links", qq[
<a href="$admin_url/p_dupl.cgi">Go Back</a>
]); 

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);

    var winl = (screen.width-ww)/2;
	 var wint = (screen.height-hh)/2;
    
    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + mywidth + ',height=' + myheight + ',top=' + wint + ',left=' + winl;
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }


function checkall(formname,thestate)
	{
	BoxNames=new Array($check_all_boxes)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

// End Hide -->
</script>

</head>
<body>
$hbox

$filter_delete_options

$form_start

$all_link_disp  

$form_end

</body>
</html>
];

}




sub checklinks
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT lnkid, url FROM links WHERE (url IS NOT NULL) AND (url != '') ORDER BY url ASC";
$sth = $dbh->prepare($sql); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$cnt = 0;
while ( @row = $sth->fetchrow() )
	{ 
		if ($row[1] eq $prev_rec)
			{
			push (@duplc, $row[0] . ":::" . $row[1]);
			}
		$prev_rec = $row[1];
	}

$sth->finish;
$dbh->disconnect; 

$dupcount = 0;
open (DUPLC, "> $data_dir/dupcheck.dat");
foreach $item (@duplc)
	{
	print DUPLC $item . "\n";
	$dupcount++;
	}
close (DUPLC);


$hbox = acs::get_heading_box("$web_url/ic_dupl2.gif", "Duplicate Link Checking Complete", qq[
Found <b>$dupcount</b> links that would create duplicates. <BR>
<a href="$admin_url/p_dupl.cgi?fct=manlinks">Click Here to Manage the links that creates duplicates</a>
]); 

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_dupl2.gif", "Duplicate Link Checker", qq[
This plugin lets you check for duplicate links inside the Directory/Index
]); 

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><p align="center"><img
    src="$web_url/ic_df.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a
    href="$admin_url/p_dupl.cgi?fct=checklinks">Check For Duplicate Links</a><br>
    </strong>Check the Directory for duplicate links. (Links that creates duplicates)</td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img src="$web_url/ic_del.gif">
    </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a
    href="$admin_url/p_dupl.cgi?fct=manlinks">Manage Duplicate Links</a><br>
    </strong>Delete or manage links that creates duplicates.</td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>
]; 




}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

